#ifndef UpperTesterCODEC_H
#define UpperTesterCODEC_H

#include "Codec.hh"
#include "loggers.hh" // TODO To be removed
#include "Params.hh"

class Base_Type;
class Record_Type;
class TTCN_Typedescriptor_t;
class TTCN_Buffer;

namespace LibItsGeoNetworking__TypesAndValues {
  class UtGnResults;
}

namespace LibItsDenm__TypesAndValues {
  class UtDenmResults;
}

class UpperTesterCodec: public Codec <
  Record_Type,
  Record_Type>
{
  const unsigned char c_utInitialize = 0x00;
  const unsigned char c_utGnInitializeResult = 0x01;
  const unsigned char c_utChangePosition = 0x02;
  const unsigned char c_utChangePositionResult = 0x03;
  const unsigned char c_utGnTriggerResult = 0x41;
  const unsigned char c_utGnTrigger_GeoUnicast = 0x50;
  const unsigned char c_utGnTrigger_GeoBroadcast = 0x51;
  const unsigned char c_utGnTrigger_GeoAnycast = 0x52;
  const unsigned char c_utGnTrigger_Shb = 0x53;
  const unsigned char c_utGnTrigger_Tsb = 0x54;

  const unsigned char c_utDenmInitializeResult = 0x01;
  const unsigned char c_utDenmTriggerResult = 0x41;

  int encode_ (const Base_Type& type, const TTCN_Typedescriptor_t& field_descriptor, TTCN_Buffer& encoding_buffer);

public:
  UpperTesterCodec() : Codec<Record_Type, Record_Type>() { loggers::get_instance().log("UpperTesterCodec::UpperTesterCodec(D)"); };
  virtual ~UpperTesterCodec() { loggers::get_instance().log("UpperTesterCodec::~UpperTesterCodec"); };

  virtual int encode (const Record_Type&, OCTETSTRING& data);
  virtual int encode (const Base_Type&, OCTETSTRING& data);
  virtual int decode (const OCTETSTRING& data, Record_Type&, Params* params = NULL);
  int decode (const OCTETSTRING& data, LibItsGeoNetworking__TypesAndValues::UtGnResults& msg, Params* params = NULL);
  int decode (const OCTETSTRING& data, LibItsDenm__TypesAndValues::UtDenmResults& msg, Params* params = NULL);
};
#endif
